//+------------------------------------------------------------------+
//|                                                      MiniMax.mq4 |
//|                                                  Victor Nicolaev |
//|                                                    Vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Victor Nicolaev"
#property link      "Vinin@mail.ru"

#property indicator_chart_window
#property indicator_buffers 2

#property indicator_color1 Yellow
#property indicator_color2 Yellow

//---- input parameters

extern double K1=34;
extern int iShift=34;
//extern double K2= 21;
//extern double K3= 13;
extern int mode=0;
//---- buffers

double HighBuffer[];
double LowBuffer[];
double dUp=-1.0,dDn=-1.0;
double k1,k2,k3;

bool  bDn=false,
      bUp=False;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   //---- drawing settings
   SetIndexShift(0,iShift);
   SetIndexShift(1,iShift);   

   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);

   
   SetIndexDrawBegin(0,0);
   SetIndexDrawBegin(1,0);


//---- indicator buffers mapping


   SetIndexBuffer(0,HighBuffer);   
   SetIndexBuffer(1,LowBuffer);    
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("VN_MiniMax");
   SetIndexLabel(0,"High");   
   SetIndexLabel(1,"Low");
//   FileName=FileName+Period()+".csv";
//   Handle=FileOpen(FileName,FILE_CSV|FILE_WRITE);
   
//---- initialization done
   k1=1.0/K1;
//   k2=1.0/K2;
//   k3=1.0/K3;
   return(0);
  }
//+------------------------------------------------------------------+
int start() {
   double PriceUp,PriceDn;
   int   limit,
         counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st buffer
   
   for (int i=limit-1; i>=0; i--) {
      Price(mode,i,PriceUp,PriceDn);
      if (dUp<0)  {dUp=PriceUp;} else  {dUp=HighBuffer[i+1];}
      if (dDn<0)  {dDn=PriceDn;} else  {dDn=LowBuffer[i+1];}
      if (PriceUp>dUp) {
         dUp=PriceUp;
         bUp=true;
         bDn=false;
      }
      if (dDn>PriceDn)  {
         dDn=PriceDn; 
         bDn=true;
         bUp=false;

      }
      if(PriceUp>=dUp && dDn>=PriceDn) {
         dUp=PriceUp; 
         dDn=PriceDn;
         bUp=false;
         bDn=false;
      }
      if (bUp) dDn=(1.0-k1)*LowBuffer[i+1]+k1*PriceDn;
      if (bDn) dUp=(1.0-k1)*HighBuffer[i+1]+k1*PriceUp;
         
      HighBuffer[i]=dUp;
      LowBuffer[i]=dDn;
   }
   return(0);
}

void Price(int mode, int i, double &PriceUp, double &PriceDn){
   switch (mode) {
      case 0: {PriceUp=High[i]; PriceDn=Low[i];break;}
      case 1: {PriceUp=MathMax(Open[i],Close[i]); PriceDn=MathMin(Open[i],Close[i]);break;}
   }
}